<template>
  <q-layout view="lHh Lpr lFf">
    <q-page-container>
      <q-page class="row" style="background: #F6F6F6">
        <div
          class="col-xs-10 col-sm-8 col-md-4 col-lg-3 col-xl-2"
          style="margin: auto"
        >
        <q-intersection
          transition="rotate"
          >
          <q-card class="shadow-up-24 q-pb-xs" style="border-radius: 40px;">
            <q-card-section class="text-white bg-primary">
              <div
                class="text-h6"
                style="text-align: center"
              >¡Bienvenido!</div>
            </q-card-section>
            <q-card-section>
            <q-form
              @submit="onSubmit"
              class="q-gutter-md q-ma-md"
            >
              <q-input
                class="q-ma-sm"
                v-model="form.email"
                label="Usuario *"
                lazy-rules
              >
                <template v-slot:prepend>
                  <q-icon name="mail"></q-icon>
                </template>
              </q-input>

              <q-input
                class="q-ma-sm"
                :type="isPwd ? 'password' : 'text'"
                v-model="form.password"
                label="Contraseña *"
                lazy-rules
                :rules="[
                  val => val && val.length > 0 || 'Ingresa tu contraseña',
                ]"
              >
                <template v-slot:prepend>
                  <q-icon name="vpn_key"></q-icon>
                </template>
                <template v-slot:append>
                  <q-icon
                    :name="isPwd ? 'visibility_off' : 'visibility'"
                    class="cursor-pointer"
                    @click="isPwd = !isPwd"
                  />
                </template>
              </q-input>
              <div class="text-center q-ma-sm">
                <q-btn
                  push
                  class="full-width q-mr-sm bg-primary text-white"
                  :loading="loading"
                  type="submit"
                >
                  Ingresar
                  <template v-slot:loading>
                    <q-spinner-hourglass class="on-left" />
                    Cargando ...
                  </template>
                </q-btn>
              </div>
              <div class="text-center q-ma-sm"><br/>
                <strong>¿No estas registrado?</strong><br/>
                <q-btn
                  online
                  class="bg-accent text-white"
                  to="/register"
                  label="Registrarme"
                  icon-right="send"
                />
              </div>
            </q-form>
            </q-card-section>
          </q-card>
          </q-intersection>
        </div>
      </q-page>
    </q-page-container>
  </q-layout>
</template>

<script>
import { mapMutations } from 'vuex'
export default {
  name: 'MyLayout',

  data () {
    return {
      form: {},
      isPwd: true,
      loading: false
    }
  },
  methods: {
    ...mapMutations('generals', ['login']),
    onSubmit () {
      this.loading = true
      this.$api.post('login', this.form).then(res => {
        if (res) { // Se debe ejecutar una mutacion que modifique el state con sessionInfo
          this.login(res)
          this.$router.push('menu')
        } else {
          this.loading = false
        }
        this.loading = false
      })
    }
  }
}
</script>
